Bug 29708 - Alias can go funny with pointer addition
Alias can go funny with pointer addition
Status: RESOLVED FIXED
Product: gcc
Classification: Unclassified
Component: tree-optimization
4.3.0
: P3 normal
: 4.3.0
Assigned To: Andrew Pinski
: alias, missed-optimization
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2006-11-04 09:13 UTC by Andrew Pinski
Modified: 2007-06-16 05:51 UTC (History)
2 users (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed: 2006-11-04 17:21:20


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Andrew Pinski 2006-11-04 09:13:49 UTC
With the following testcase:
int a[100], b[100], d[100];

void link_error (void);
int g(int i, int j)
{
  int *c;
  int t;
  c = i?a:b;
  c++;
  d[j] = 1;
  c[j] = 2;
  if (d[j] != 1)
    link_error ();
  return 0;
}
----
May-alias should figure out that c can only pointer to a or b but it gets confused as we get:
  j.2_11 = (unsigned int) j_7;
  D.1537_12 = j.2_11 * 4;
  D.1538_13 = (int *) D.1537_12;
  D.1539_14 = D.1538_13 + c_6;
  *D.1539_14 = 2;

as may-alias only looks at the left hand side of a PLUS expression, we get the following result:
D.1538_13 = &ANYTHING
D.1539_14 = D.1538_13

Note 4.1 optimzed this testcase but I think that was by accident and is not actually getting it correct.

If we add PTR_PLUS_EXPR we get the correct answer all the time unless someone does some real weird tricks by doing something like:

size_t t = (size_t)a;
int *c = (int*)(size_t)j;
*(c+t) = 2;
Comment 1 Richard Biener 2006-11-04 17:21:20 UTC
Confirmed.
Comment 2 Andrew Pinski 2007-05-22 01:51:48 UTC
Mine, we always get the correct answer on the pointer plus branch.

On the trunk:
ANYTHING = &ANYTHING
READONLY = &ANYTHING
INTEGER = &ANYTHING
a = &ANYTHING
c_1 = &a
b = &ANYTHING
c_1 = &b
c_6 = c_1 + 32
D.1639_11 = &ANYTHING
D.1640_12 = D.1639_11
D.1640_12 = c_6
  *D.1640_12 = 2;

While on the branch:
ANYTHING = &ANYTHING
READONLY = &ANYTHING
INTEGER = &ANYTHING
a = &ANYTHING
c_1 = &a
b = &ANYTHING
c_1 = &b
c_6 = c_1 + 32
D.1639_11 = c_6
  *D.1639_11 = 2;

So there is no extra Constraint for the store to &ANYTHING.

Comment 3 Andrew Pinski 2007-06-16 05:50:15 UTC
Fixed at revision 125755.